"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const memcached_wrapper_1 = require("./memcached.wrapper");
const common_1 = require("@nestjs/common");
const nest_common_1 = require("nest-common");
let MemcachedModule = MemcachedModule_1 = class MemcachedModule {
    static register(options) {
        const inject = [];
        if (options.dependencies) {
            if (options.dependencies.indexOf(nest_common_1.NEST_BOOT) !== -1) {
                inject.push(nest_common_1.NEST_BOOT_PROVIDER);
            }
            if (options.dependencies.indexOf(nest_common_1.NEST_CONSUL_CONFIG) !== -1) {
                inject.push(nest_common_1.NEST_CONSUL_CONFIG_PROVIDER);
            }
        }
        if (options.adapter === nest_common_1.NEST_BOOT) {
            inject.push(nest_common_1.NEST_BOOT_PROVIDER);
        }
        else if (options.adapter === nest_common_1.NEST_CONSUL_CONFIG) {
            inject.push(nest_common_1.NEST_CONSUL_CONFIG_PROVIDER);
        }
        const connectionProvider = {
            provide: nest_common_1.NEST_MEMCACHED_PROVIDER,
            useFactory: (config) => __awaiter(this, void 0, void 0, function* () {
                if (options.dependencies) {
                    if (options.dependencies.indexOf(nest_common_1.NEST_BOOT) !== -1) {
                        options = config.get('memcached');
                    }
                    if (options.dependencies.indexOf(nest_common_1.NEST_CONSUL_CONFIG) !== -1) {
                        options = yield config.get('memcached');
                    }
                }
                if (options.adapter === nest_common_1.NEST_BOOT) {
                    options = config.get('memcached');
                }
                else if (options.adapter === nest_common_1.NEST_CONSUL_CONFIG) {
                    options = yield config.get('memcached');
                }
                return yield new memcached_wrapper_1.Memcached(options.uri, options);
            }),
            inject,
        };
        return {
            module: MemcachedModule_1,
            components: [connectionProvider],
            exports: [connectionProvider],
        };
    }
};
MemcachedModule = MemcachedModule_1 = __decorate([
    common_1.Global(),
    common_1.Module({})
], MemcachedModule);
exports.MemcachedModule = MemcachedModule;
var MemcachedModule_1;
